<?php

namespace REDO;

if (!defined('ABSPATH')) exit;

// This file is pretty much a boilerplate WordPress plugin.
// It does very little except including wp-widget.php

class E_REDO
{

   public function __construct()
   {
     
      add_action('init', [$this, 'check_for_install']);
      add_action('elementor/widgets/widgets_registered', [$this, 'register_widgets']);
   }


   private function include_widgets_files()
   {
      require_once(__DIR__ . '/widgets/projekty.php');
      require_once(__DIR__ . '/widgets/customPostRedo.php');
      require_once(__DIR__ . '/widgets/slider.php');
   }

   public function register_widgets()
   {
      $this->include_widgets_files();
      \Elementor\Plugin::instance()->widgets_manager->register_widget_type(new Widgets\Projekty());
      \Elementor\Plugin::instance()->widgets_manager->register_widget_type(new Widgets\CustomPostRedo());
      \Elementor\Plugin::instance()->widgets_manager->register_widget_type(new Widgets\Slider());
   }

   public static function debug($var, $die = false)
   {
      echo "<pre>";
      print_r($var);
      echo "</pre>";
      if ($die) die();
   }
   //$customPostList = get_option( 'cptui_post_types' );
   
   private static function parseCustomFields($fieldList, &$fields, $group){
      foreach($fieldList as $field){
         
          $fields[$group]["fields"][$field["name"]]["value"] = $field["name"];
          
      }
   }

  public static function prepareCustomFields()
   {
      if(defined('ACF_VERSION')){
      /*
       * Pobierz listę stworzonych grup
       */
      $groups = acf_get_raw_field_groups();
      //VC_REDO::debug($groups, true);
      $fields = array();
      /**
       * przygotuj liste pol sortowane po grupach
       */
      foreach($groups as $group){
          
          $fields[$group["ID"]]["title"] = $group["title"];
          $type = '';
          foreach($group["location"] as $key => $value) {
             foreach($value as $param) {
               $type = $param["value"];
             }
          }
          //E_REDO::debug($type, true);
          $fields[$group["ID"]]["type"] = $type;
          $field_list = acf_get_fields($group["ID"]);
          
          self::parseCustomFields($field_list, $fields, $group["ID"]);
      }
      }
      return $fields;
   }



   public function check_for_install()
   {
      E_REDO::show_redo_warning();
      return;
   }
   private function show_redo_warning()
   {
      if (!defined('ELEMENTOR_VERSION')) {
         $link = "https://pl.wordpress.org/plugins/elementor/";
         $plugin = "Elementor Page Builder";
?>
         <div class="notice notice-warning is-dismissible">
            <p>Please install <a href="<?php echo $link; ?>"><?php echo $plugin; ?></a> to use REDO JSComposer
               Additional.</p>
         </div>
      <?php
      }
      if (!defined('CPT_VERSION')) {
         $link = "https://pl.wordpress.org/plugins/custom-post-type-ui/";
         $plugin = "Custom Post Type UI";
      ?>
         <div class="notice notice-warning is-dismissible">
            <p>Please install <a href="<?php echo $link; ?>"><?php echo $plugin; ?></a> to use REDO JSComposer
               Additional.</p>
         </div>
      <?php
      }
      if (!defined('ACF_VERSION')) {
         $link = "https://pl.wordpress.org/plugins/advanced-custom-fields/";
         $plugin = "Advanced Custom Fields";
      ?>
         <div class="notice notice-warning is-dismissible">
            <p>Please install <a href="<?php echo $link; ?>"><?php echo $plugin; ?></a> to use REDO JSComposer
               Additional.</p>
         </div>
<?php
      }
   }

}
